
H = [alpha=1.4, beta=0.3] z -> [z[2] + 1-alpha*z[1]^2, beta*z[1]];

z0 = [1, 1];

for k = 1 : 300
   z0 = H(z0);
end

N = 2000;

Z = zeros(N, 2);
Z[1, :] = z0;
for k = 2 : N
    Z[k, :] = H(Z[k-1, :]);
end

with("plot.x");

fig1 = figure.new();
fig1.plot{x=Z[:,1], y=Z[:,2], linetype="dot", linewidth=0.2};
fig1.save("henon.eps");


N=100;
W = zeros(N, 2);
W[1, :] = z0 + [0.001, -0.001];
for k = 2 : N
    W[k, :] = H(W[k-1, :]);
end

P = zeros(N);
for k = 1 : N
    P[k] = norm(Z[k,:]-W[k,:]);
end

fig2 = figure.new();
fig2.plot{x=1:N, y=P};
fig2.save("solerror.eps");

