
// given vectors x and y, return the interpolating polynomial (as a function)

// example
// f = interp([1,2,3], [-2, 0, 5]);
// xx = linspace(1, 3);
// yy = f(xx);

interp = function (x, y) -> pfunc
         
         if (! (x in _Rn)) || (! (y in _Rn)) || (x.length != y.length)
             panic("invalid arguments"); 
         end


         n = x.length;

         coeff = y;
         c = y;

         for k = 2 : n
              for j = k : n
                   c[j] = (coeff[j] - coeff[j - 1]) / (x[j] - x[j - (k - 1)]);
              end

              for j = k : n
                   coeff[j] = c[j];
              end
         end

         pfunc = function [x = x, coeff = coeff] xx -> yy
                n = x.length;
                yy = coeff[n];

                for k = n : -1 : 2
                   yy = yy .* (xx - x[k - 1]) + coeff[k - 1];
                end

         end
end

